#!/usr/bin/luaweb
dofile('lua.inc')
dofile('cgi.inc')
require('json')
require('lfs')

function certInfo()
	cert=os.captureN("/usr/bin/openssl x509 -in /data/cert.pem -noout -subject")
	valid=os.captureN('[ -e /data/cert.pem ] && openssl x509 -in /data/cert.pem -noout -enddate | awk -F "=" \'{print $2}\' | awk -F " " \'{print $1" "$2" "$4" "$5}\' || echo No Cert found!')
	local results={}
	split=Split(cert,"/")
	for k,v in pairs(split)do
	    if(v ~= "subject= ")then
	        cred=Split(v,"=")
	        results[cred[1]]=cred[2]
    	end
	end

	results["valid until"]=valid
	return(results)
end

function changeDate(file)
    attr = lfs.attributes(file)
    if(attr == nil)then
        return(false)
    end
    assert (type(attr))
--    return(attr.modification)
   return(attr.change)
--   return(attr.access)
end

function getTable(file)
	myFile=io.open("/tmp/"..file,r)
	c=1
    myTable={}
    for line in myFile:lines() do
    	myTable[c]=line
        c=c+1
    end
	return (myTable)
end


function execCommand(cmd)
	f = assert (io.popen (cmd))
	local i=1
	local myTable={}
  	for line in f:lines() do
--	print(line)
        line = string.gsub(line, '\'', '"')
        myTable[i]=line
        i=i+1
	end -- for loop
	f:close()
   return myTable
end


function routingTable()
	local table={}
	table["inbound"]={}
	table["outbound"]={}
	filterIn="inbound_call_"
	filterOut="outbound_call_"
	files=listFiles("/tmp")
	i=1
	o=1
	for k, file in pairs(files) do
            if string.find(file,filterIn) then
				table["inbound"][i]={}
				attr = lfs.attributes(file)
				table["inbound"][i]["change"]=changeDate(file)
				inboundRouteFile=io.open(file,r)
				c=1
				inlines={}
				for inline in inboundRouteFile:lines() do
					inlines[c]=inline
					c=c+1
				end
				file=string.gsub(file,"/tmp/","")
				dchan=string.gsub(file,"inbound_call_","")
				dchan=string.gsub(dchan,".log","")
			
--				table["inbound"][i]["route"]=inlines
				table["inbound"][i]["file"]=file
				table["inbound"][i]["dchan"]=dchan
				i=i+1
			end
            if string.find(file,filterOut) then
				table["outbound"][o]={}
				attr = lfs.attributes(file)
				table["outbound"][o]["change"]=changeDate(file)
				outboundRouteFile=io.open(file,r)

			 	d=1
                outlines={}
                for outline in outboundRouteFile:lines() do
                    outlines[d]=outline
                    d=d+1
                end
--				table["outbound"][o]["route"]=outlines
				file=string.gsub(file,"/tmp/","")
				dchan=string.gsub(file,"outbound_call_","")
				dchan=string.gsub(dchan,".log","")
				table["outbound"][o]["file"]=file
				table["outbound"][o]["dchan"]=dchan
				o=o+1
			end
	end
return table
end


function connectionTable()
	local cons={}
	bchan=request_param("bchan")
    dchan=request_param("dchan")
	cons["connections"]=getBchannelFiles("/tmp/",dchan,bchan)
	cons["info"]="some"
	return cons
end

function syslog()
	local dmesg={}
    lines=request_param("lines")
    filter=request_param("filter")
    l2xfilter=request_param("l2xfilter")
	SIPMSGfilter=request_param("SIPMSGfilter")
	SIPCMDfilter=request_param("SIPCMDfilter")
	ISDNCMDfilter=request_param("ISDNCMDfilter")
	ISDNMSGfilter=request_param("ISDNMSGfilter")
	JOBCMDfilter=request_param("JOBCMDfilter")
	customfilter=request_param("customfilter")

	egrepFilter="'"
	filterString=" "
	if(filter == "true")then
		filterString=filterString.." | sed s/.*$(hostname)//g -"	
	end
	if(l2xfilter=="true")then
		filterString=filterString.."| grep -v ': L2X :'"	
	end
	if(SIPMSGfilter == "true")then
		egrepFilter=egrepFilter.."|SIPMSG"	
	end
	if(SIPCMDfilter == "true")then
		egrepFilter=egrepFilter.."|SIPCMD"
	end
	if(ISDNCMDfilter == "true")then
		egrepFilter=egrepFilter.."|ISDNCMD"
	end

	if(ISDNMSGfilter == "true")then
		egrepFilter=egrepFilter.."|ISDMSG"
	end
	if(JOBCMDfilter == "true")then
		egrepFilter=egrepFilter.."|JOBCMDfilter"
	end
	if(customfilter ~= "nil" and customfilter ~= nil)then
		egrepFilter=egrepFilter.."|"..customfilter
	end

	egrepFilter=egrepFilter.."'"
	egrepFilter=string.gsub(egrepFilter, "|", "", 1)
    if(lines==nil)then 
    	lines=50
    end
	dmesg["stdout"]=stdout2table("/usr/bin/sudo tail /tmp/logs/syslog.olg -n "..lines.." "..filterString.." | egrep "..egrepFilter)
	dmesg["info"]=lines
	return dmesg
end

function capture()
	local capture={}
    lines=request_param("lines")
    if(lines==nil)then lines=15 end
	capture["stdout"]=stdout2table("/usr/bin/sudo tcpdump -a -n -q -r /tmp/logs/capture.cap | tail -n "..lines)
	--[[ options:
		-n don't resolve hostnames, use IP
		-N no domain name qualification	
		-a not using name resolv at all ..think of buggy dns serv
		]]--
	capture["info"]=lines
	return capture
end

function sysInfo()
	local sysInfo={}
	--sysInfo["fw"]=os.captureN("omgsysteminfo --filter=fw --json")
	sysInfo["os"]={}	--store operating system infos
	sysInfo["sw"]={}	--store software infos
	sysInfo["hw"]={}	--store hardware infos
	sysInfo["i2c"]={}	--store i2c infos
	sysInfo["lic"]={}	--store license infos
	sysInfo["uptime"]={}--store uptime infos
	sysInfo["jcInfo"]={}--store connection infos
	sysInfo["loadavg"]={}
	sysInfo["loadavg1"]={}
	sysInfo["loadavg2"]={}
	sysInfo["date"]={}
	sysInfo["kernel"]={}
	sysInfo["Dlic"]={}
	sysInfo["Blic"]={}
	sysInfo["licinfo"]={}
	sysInfo["df_h"]=stdout2KVtable("LC_ALL=C /bin/df -h /data /tmp/logs | sed 's/\\/tmp\\/logs/weblog/g' | awk -F \" \" '{print $2\" \"$3\" \"$4\" \"$5\" \"$6}'>&1 ","\t ")
	sysInfo["resolvconf"]=stdout2table("cat /etc/resolv.conf | grep -v ^#")
	sysInfo["route-n"]=stdout2KVtable("LC_ALL=C /sbin/route -n 2>&1 | sed -e '1,1d' - ","\t")  --delete first output row
	sysInfo["licinfo"]=cmd2kvTable("licinfo -d",":",4)
	sysInfo.os["hostName"]=os.captureN("/bin/hostname")
--	sysInfo.os["isLocalLog"]=os.captureN("grep -q '@' /etc/rsyslog.d/50-default.conf; echo $?")
	--sysInfo.os["codeName"]=os.captureN('cat /etc/lsb-release  | grep DISTRIB_CODENAME | sed s/.*=//')


	if(exists("/etc/lsb-release"))then
		sysInfo.os["distribution"]=os.captureN('cat /etc/lsb-release | grep  DISTRIB_DESCRIPTION | sed "s/Ubuntu//g" - | sed s/.*=\\"//g - | sed s/\\"$//g -')
		local dpkgInfo=stdout2table("dpkg -l | egrep -e '(omg-modules|omg-userfs|omg-utilities)' | awk -F ' ' '{print $2\"=\"$3}' ")
		for k,line in pairs(dpkgInfo)do
			local split=Split(line,"=")
			sysInfo.sw[split[1]]=split[2]
		end
	else
		local omgsysteminfo = json.decode(os.captureN("omgsysteminfo --json"))
		sysInfo.os["distribution"]=omgsysteminfo.os.name.." "..omgsysteminfo.os.version
		sysInfo.sw["omg-userfs"]=omgsysteminfo.fw.packages.omg
		sysInfo.sw["omg-modules"]=omgsysteminfo.fw.packages["omg-modules"]
		sysInfo.sw["omg-utilities"]=""
		
	end
	
	

	sysInfo.sw["featureVersion"]=os.captureN('cat /tmp/cmdline   2>/dev/null| grep FEATUREVERSION= | sed s/.*=//g')
	

--[[	unused
	local i2cinfo=stdout2table("/usr/bin/sudo /usr/bin/i2cinfo | grep -v '^Single Unit'")
	for c,info in pairs(i2cinfo)do
		local cSplit = Split(info," is ")
			sysInfo.i2c[ cSplit[1] ] = cSplit[2]
	end
--]]
--	sysInfo.i2c["Board revision"]=os.captureN("/usr/bin/sudo i2cinfo | grep 'Board revision' | sed s/.*.is\\ //g -")
--   sysInfo.i2c["Serial number"]=os.captureN("/usr/bin/sudo i2cinfo | grep '^Serial number' | sed s/.*.is\\ //g -")
-- 	 sysInfo.i2c["HW Serial number"]=os.captureN("/usr/bin/sudo i2cinfo | grep '^HW Serial number' | sed s/.*.is\\ //g -" )

	sysInfo.kernel["kernel"]=os.capture('uname -r | tr -d "\n"')

	if(exists("/sbin/showlic"))then
		liccmd=("/sbin/showlic")
	else
		liccmd=("/usr/bin/showlic")
	end


	local showlicInfo=os.captureN("/usr/bin/sudo "..liccmd.." 2>&1")
	local licSplit=Split(showlicInfo,", ")
	for f,g in pairs(licSplit)do
		if(string.find(g, "UM B%-Channels") ~= nil)then
			sysInfo.Blic["blic"]=Split(g,":")[2]
		end	
		if(string.find(g, "D%-Channels") ~= nil)then
			sysInfo.Dlic["dlic"]=Split(g,":")[2]
		end

	end
	--[[sysInfo.lic["showlic"]=os.captureN("/usr/bin/sudo /usr/bin/showlic 2>&1")
		sysInfo.Dlic["dlic"]=os.captureN("showlic | awk -F \",\" '{print $1}'| sed s/.*://g -")
		sysInfo.Blic["blic"]=os.captureN("showlic | awk -F \", \" '{print $2}' | sed s/.*:\\ //g")
		sysInfo.lic["getchannels"]=os.captureN("/usr/bin/sudo /usr/bin/getchannels 2>&1")
	]]--
--	sysInfo.uptime["uptime"]=os.captureN('uptime |cut -c11- | awk -F ...." user" \'{print $1}\'')
	sysInfo.date["date"]=os.captureN('/bin/date +"%Y-%m-%d %T"')

--[[	sysInfo.loadavg["loadavg"]=os.capture('cat /proc/loadavg | awk -F " " \'{print $1"%"}\' | cut -c3- | tr -d "\n" ')
	sysInfo.loadavg1["loadavg1"]=os.capture('cat /proc/loadavg | awk -F " " \'{print $2"%"}\' | cut -c3- | tr -d "\n" ')
	sysInfo.loadavg2["loadavg2"]=os.capture('cat /proc/loadavg | awk -F " " \'{print $3"%"}\' | cut -c3- | tr -d "\n" ')
]]--
	local uptime=os.capture("/usr/bin/uptime")
	upSplit = Split(uptime,"up")
	up=Split(upSplit[2],",")
	sysInfo.uptime["uptime"]=up[1]..up[2]
	numberOfCores=os.capture("cat /proc/cpuinfo | grep -c processor")
	loadAvg=(Split(upSplit[2],"load average: ")[2])
	loads=Split(loadAvg,", ")
        sysInfo.loadavg["loadavg"]=loadAvg
--[[	sysInfo.loadavg["loadavg"]=(loads[1]/numberOfCores*100).."%"
	sysInfo.loadavg["loadavg1"]=(loads[2]/numberOfCores*100).."%"
	sysInfo.loadavg["loadavg2"]=(loads[3]/numberOfCores*100).."%"
--]]



	sysInfo.jcInfo["jcInfo"]=jcInfo()
	return sysInfo
end

function sippCheck()
	local sippCheck={}
	sippCheck["check"]=os.capture("pidof sipp 2>&1 >/dev/null ;echo -n $?")
	return sippCheck
end
function sippKill()
	local sippKill={}
	sippKill["kill"]=os.capture("/usr/bin/sudo /usr/bin/killall -s 9 sipp >/dev/null 2>&1; echo -n $?")
	return sippKill
end
function dmesg()
	local dmesg={}
	dmesg=stdout2table("/bin/dmesg")
	return dmesg
end



function main()
    envcmd='. /tmp/cmdline && for i in $(env | sort | grep -vi cgi | grep -vi http | grep -v SREVER_NAME | grep -v SERVER_PORT | grep -v REQUEST_METHOD | grep -v SHLVL | grep -v printenv | grep -v console | grep -v root | grep -v wdt) ;do echo $i; done | grep \"=\"'
    method=request_param("method")
    option=request_param("option")
    file=request_param("file")
    command=request_param("command")
	host=request_param("host")



    if(command == nil)then 	--helps debugging
		command="sysInfo"
--		command="connectionTable"
		--command="certInfo"
		--command="syslog"
		--command="lsof_callp"
		--	host="google.de"
		--	command="testKV"
		--  file="outbound_call_1.log"
 	end
	
	if(host)then
		semi=(string.find (host, ";"))
		excl=(string.find (host, "!"))
		if((excl ~= nil) or (semi ~= nil))then
			print('{"command":["You passed an invalid and dangerous character!"]}')
			return false	
		end
	end

	 if (command=="netstat") then print('{"command":'..json.encode(stdout2table("/bin/netstat -anp -A inet | head -n 1000"))..'}') 
--		elseif (command=="uptime") then print('{"command":'..json.encode(stdout2table("/usr/bin/uptime"))..'}')
		elseif (command=="procs") then print('{"command":'..json.encode(stdout2table("/bin/ps ax | tail -n 1000 | sed -e 's/<//g'"))..'}')
		elseif (command=="ifconfig") then print('{"command":'..json.encode(stdout2table("/sbin/ifconfig"))..'}')
		elseif (command=="environment") then print('{"kv_command":'..environment()..'}')
		
		elseif (command=="lsof_callp") then print('{"command":'..json.encode(stdout2table("echo Last Refresh: $(date); echo ' ' ;echo ' ' ;/usr/bin/lsof | head -n1 ; /usr/bin/sudo /usr/bin/lsof | grep callp"))..'}')
		elseif (command=="instancePrint") then print('{"command":'..json.encode(stdout2table("echo Last Refresh: $(date); echo ' ' ;echo ' ' ;cat /tmp/instancePrint.txt"))..'}')
		

		elseif (command=="ping") then 
			if(string.match(host,":")==nil)then
				print('{"command":'..json.encode(stdout2table("/bin/ping -c4 "..host.." 2>&1"))..'}')
			else
				print('{"command":'..json.encode(stdout2table("/bin/ping6 "..host.." 2>&1"))..'}')
			end
		
		elseif (command=="trace") then print('{"command":'..json.encode(execCommand("/usr/bin/sudo /usr/bin/tracepath -n "..host.." 2>&1"))..'}')
		elseif (command=="stderr") then print('{"command":'..json.encode(stdout2table("stderr 2>&1"))..'}')

		elseif (command=="routingTable") then print('{"command":'..json.encode(routingTable())..'}')
		elseif (command=="getTable") then print('{"command":'..json.encode(getTable(file))..'}')
		

		elseif (command=="dmesg") then print('{"command":'..json.encode(dmesg())..'}')
--		elseif (command=="i2cinfo") then print('{"command":'..json.encode(i2cinfo())..'}')
		elseif (command=="sippCheck") then print('{"command":'..json.encode(sippCheck())..'}')
		elseif (command=="sippKill") then print('{"command":'..json.encode(sippKill())..'}')
--		elseif (command=="osInfo") then print('{"command":'..json.encode(osInfo())..'}')
		elseif (command=="sysInfo") then print('{"command":'..json.encode(sysInfo())..'}')
		

--		elseif (command=="trace") then print('{"command":'..json.encode(stdout2table("/tmp/test.sh"))..'}')
		elseif (command == "certInfo")then
			printJs(certInfo())
		elseif (command=="connectionTable") then
			 --webData["connectionTable"]=connectionTable()
			print(json.encode(connectionTable()))
		
        elseif (command=="testKV") then print('{"kv_command":'..json.encode(cmd2kvTable(envcmd,"=",2))..'}')

--		elseif (command=="testKV") then print('{"kv_command":'..json.encode(cmd2kvTable("licinfo -d",":",4))..'}')
--		elseif (command=="connectionInfo") then print('{"kv_command":'..json.encode(jcInfo())..'}')



		elseif (command=="syslog") then
			print(json.encode(syslog()))	
		elseif (command=="capture") then
			print(json.encode(capture()))

    end
end


print ("Content-type: application/json\n")

webData={}
main()

